%global version_release 1
%global commitid 502ff4ac93d193a71ad57fa752622e8970071227
%global serial 24
%global meadalpha %{nil}
%global meadrel %{nil}
%global version_major 1
%global version_minor 17
%global version_micro 5

%global orprefix            %{_usr}/local/%{name}
%global zlib_prefix         %{orprefix}/zlib
%global pcre_prefix         %{orprefix}/pcre


%if 0%{?fedora} >= 27
%undefine _debugsource_packages
%undefine _debuginfo_subpackages
%endif

Name:           openresty
Version:        %{version_major}.%{version_minor}.%{version_micro}
Release:        %{serial}%{?dist}
Summary:        OpenResty, scalable web platform by extending NGINX with Lua

Group:          System Environment/Daemons

# BSD License (two clause)
# http://www.freebsd.org/copyright/freebsd-license.html
License:        BSD
URL:            https://openresty.org/

Source0: openresty-%{commitid}.tar.gz
Source1: nginx-apicast-release-1.17.4.tar.gz
Source2: echo-nginx-module-v0.61.tar.gz
Source3: xss-nginx-module-v0.06.tar.gz
Source4: ngx_devel_kit-v0.3.1rc1.tar.gz
Source5: set-misc-nginx-module-v0.32.tar.gz
Source6: rds-json-nginx-module-v0.15.tar.gz
Source7: rds-csv-nginx-module-v0.09.tar.gz
Source8: headers-more-nginx-module-v0.33.tar.gz
Source9: drizzle-nginx-module-v0.1.11.tar.gz
Source10: lua-nginx-module-da5ef31cbfbb096475f81f4823f8c45c0deb6d97.tar.gz
Source11: lua-upstream-nginx-module-v0.07.tar.gz
Source12: stream-lua-nginx-module-c7ac2234ec7a26bdcd3b17cbb5314f17344f9f5c.tar.gz
Source13: array-var-nginx-module-v0.05.tar.gz
Source14: memc-nginx-module-v0.19.tar.gz
Source15: srcache-nginx-module-v0.31.tar.gz
Source16: form-input-nginx-module-v0.12.tar.gz
Source17: iconv-nginx-module-v0.14.tar.gz
Source18: encrypted-session-nginx-module-v0.08.tar.gz
Source19: ngx_http_redis-0.3.7.tar.gz
Source20: ngx_postgres-1.0.tar.gz
Source21: ngx_coolkit-0.2.tar.gz
Source22: redis2-nginx-module-v0.15.tar.gz
Source23: resty-cli-v0.25rc2.tar.gz
Source24: opm-v0.0.5.tar.gz
Source25: luajit2-v2.1-20190912.tar.gz
Source26: lua-cjson-2.1.0.7.tar.gz
Source27: lua-redis-parser-v0.13.tar.gz
Source28: lua-rds-parser-v0.06.tar.gz
Source29: lua-resty-dns-v0.21.tar.gz
Source30: lua-resty-memcached-v0.14.tar.gz
Source31: lua-resty-redis-v0.27.tar.gz
Source32: lua-resty-mysql-v0.21.tar.gz
Source33: lua-resty-limit-traffic-v0.06.tar.gz
Source34: lua-resty-upload-v0.10.tar.gz
Source35: lua-resty-string-v0.12rc1.tar.gz
Source36: lua-resty-websocket-v0.07.tar.gz
Source37: lua-resty-lock-v0.08.tar.gz
Source38: lua-resty-lrucache-v0.09.tar.gz
Source39: lua-resty-core-e0aba0b77e606cd1af43caeddf788999f842653d.tar.gz
Source40: lua-resty-upstream-healthcheck-v0.06.tar.gz
Source41: lua-tablepool-v0.01.tar.gz
Source42: lua-resty-signal-v0.02.tar.gz
Source43: lua-resty-shell-v0.02.tar.gz
Source44: nginx-opentracing-v0.3.0.tar.gz
Source45: apicast-nginx-module-v0.1.tar.gz

BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)

BuildRequires:  perl-File-Temp, dos2unix, pcre-devel, openssl-devel
BuildRequires:  gcc, make, perl, systemtap-sdt-devel, git
BuildRequires:  openresty-zlib-devel >= 1.2.11-3
BuildRequires:  openresty-pcre-devel >= 8.42-1
BuildRequires:  opentracing-cpp-devel >= 1.3.0
Requires:       openresty-zlib >= 1.2.11-3
Requires:       openresty-pcre >= 8.42-1


AutoReqProv:        no


%description
This package contains the core server for OpenResty. Built for production
uses.

OpenResty is a full-fledged web platform by integrating the standard Nginx
core, LuaJIT, many carefully written Lua libraries, lots of high quality
3rd-party Nginx modules, and most of their external dependencies. It is
designed to help developers easily build scalable web applications, web
services, and dynamic web gateways.

By taking advantage of various well-designed Nginx modules (most of which
are developed by the OpenResty team themselves), OpenResty effectively
turns the nginx server into a powerful web app server, in which the web
developers can use the Lua programming language to script various existing
nginx C modules and Lua modules and construct extremely high-performance
web applications that are capable to handle 10K ~ 1000K+ connections in
a single box.


%package resty

Summary:        OpenResty command-line utility, resty
Group:          Development/Tools
Requires:       perl, openresty >= %{version}-%{release}
Requires:       perl(File::Spec), perl(FindBin), perl(List::Util), perl(Getopt::Long), perl(File::Temp), perl(POSIX), perl(Time::HiRes)

%if 0%{?fedora} >= 10 || 0%{?rhel} >= 6 || 0%{?centos} >= 6
BuildArch:      noarch
%endif


%description resty
This package contains the "resty" command-line utility for OpenResty, which
runs OpenResty Lua scripts on the terminal using a headless NGINX behind the
scene.

OpenResty is a full-fledged web platform by integrating the standard Nginx
core, LuaJIT, many carefully written Lua libraries, lots of high quality
3rd-party Nginx modules, and most of their external dependencies. It is
designed to help developers easily build scalable web applications, web
services, and dynamic web gateways.



%package opm

Summary:        OpenResty Package Manager
Group:          Development/Tools
Requires:       perl, openresty >= %{version}-%{release}, perl(Digest::MD5)
Requires:       openresty-resty >= %{version}-%{release}
Requires:       curl, tar, gzip
#BuildRequires:  perl(Digest::MD5)
Requires:       perl(Encode), perl(FindBin), perl(File::Find), perl(File::Path), perl(File::Spec), perl(Cwd), perl(Digest::MD5), perl(File::Copy), perl(File::Temp), perl(Getopt::Long)

%if 0%{?fedora} >= 10 || 0%{?rhel} >= 6 || 0%{?centos} >= 6
BuildArch:      noarch
%endif


%description opm
This package provides the client side tool, opm, for OpenResty Pakcage Manager (OPM).

%package opentracing

Summary:        Opentracing module


%description opentracing
This package provides the opentracing module in Openresty.


%prep
ls -la %{_sourcedir}
%setup -q -n "openresty-%{commitid}"
cp %{SOURCE0} .
cp %{SOURCE1} .
cp %{SOURCE2} .
cp %{SOURCE3} .
cp %{SOURCE4} .
cp %{SOURCE5} .
cp %{SOURCE6} .
cp %{SOURCE7} .
cp %{SOURCE8} .
cp %{SOURCE9} .
cp %{SOURCE10} .
cp %{SOURCE11} .
cp %{SOURCE12} .
cp %{SOURCE13} .
cp %{SOURCE14} .
cp %{SOURCE15} .
cp %{SOURCE16} .
cp %{SOURCE17} .
cp %{SOURCE18} .
cp %{SOURCE19} .
cp %{SOURCE20} .
cp %{SOURCE21} .
cp %{SOURCE22} .
cp %{SOURCE23} .
cp %{SOURCE24} .
cp %{SOURCE25} .
cp %{SOURCE26} .
cp %{SOURCE27} .
cp %{SOURCE28} .
cp %{SOURCE29} .
cp %{SOURCE30} .
cp %{SOURCE31} .
cp %{SOURCE32} .
cp %{SOURCE33} .
cp %{SOURCE34} .
cp %{SOURCE35} .
cp %{SOURCE36} .
cp %{SOURCE37} .
cp %{SOURCE38} .
cp %{SOURCE39} .
cp %{SOURCE40} .
cp %{SOURCE41} .
cp %{SOURCE42} .
cp %{SOURCE43} .
tar xzf %{SOURCE44}
tar xzfv %{SOURCE45}
tar -ztvf %{SOURCE45}
echo "START FIND"
find .
echo "END FIND"



%build
export LDFLAGS="%{?__global_ldflags}"
export CFLAGS="%{optflags}"
make %{?_smp_mflags}
ls -lah
cd $(ls -1 | grep openresty | grep -v "tar.gz")
ls -lah
ls -lah bundle/
./configure \
    --prefix="%{orprefix}" \
    --with-cc-opt="%{optflags} -DNGX_LUA_ABORT_AT_PANIC -I%{zlib_prefix}/include -I%{pcre_prefix}/include -I$(pwd)/../apicast-nginx-module-v0.1/" \
    --with-ld-opt="%{?__global_ldflags} -L%{zlib_prefix}/lib -L%{pcre_prefix}/lib -Wl,-rpath,%{zlib_prefix}/lib:%{pcre_prefix}/lib -L$(pwd)/../apicast-nginx-module-v0.1/" \
    --with-pcre-jit \
    --without-http_rds_json_module \
    --without-http_rds_csv_module \
    --without-lua_rds_parser \
    --with-stream \
    --with-stream_ssl_module \
    --with-stream_ssl_preread_module \
    --with-http_v2_module \
    --without-mail_pop3_module \
    --without-mail_imap_module \
    --without-mail_smtp_module \
    --with-http_stub_status_module \
    --with-http_realip_module \
    --with-http_addition_module \
    --with-http_auth_request_module \
    --with-http_secure_link_module \
    --with-http_random_index_module \
    --with-http_gzip_static_module \
    --with-http_sub_module \
    --with-http_dav_module \
    --with-http_flv_module \
    --with-http_mp4_module \
    --with-http_gunzip_module \
    --with-threads \
    --add-module="../apicast-nginx-module-v0.1/" \
    --add-dynamic-module="../nginx-opentracing-v0.3.0/opentracing" \
    --with-luajit-target-strip="Q='' CFLAGS='' TARGET_XCFLAGS='-D_FILE_OFFSET_BITS=64 -D_LARGEFILE_SOURCE' TARGET_FLAGS='%{optflags}' HOST_CC='%{__cc}' STATIC_CC='%{__cc}' DYNAMIC_CC='%{__cc} -fPIC' HOST_CFLAGS='%{optflags}' HOST_LDFLAGS='%{?__global_ldflags}'" \
    --with-dtrace-probes
# make %{?_smp_mflags} CFLAGS='-pipe  -O -W -Wall -Wpointer-arith -Wno-unused-parameter -Werror -g'
make %{?_smp_mflags} MY_LDFLAGS="%{?__global_ldflags} -shared" CC="%{__cc}"
# for file in $(find . | grep "\.o$"); do echo $file; annocheck -v $file || exit 0; done

%install
rm -rf %{buildroot}
ls -lsh
cd $(ls -1 | grep openresty | grep -v "tar.gz")
make install DESTDIR=%{buildroot}

rm -rf %{buildroot}%{orprefix}/luajit/share/man
rm -rf %{buildroot}%{orprefix}/luajit/lib/libluajit-5.1.a

mkdir -p %{buildroot}%{_bindir}
ln -sf %{orprefix}/bin/resty %{buildroot}%{_bindir}/
# ln -sf %{orprefix}/bin/restydoc %{buildroot}%{_bindir}/
ln -sf %{orprefix}/bin/opm %{buildroot}%{_bindir}/
ln -sf %{orprefix}/nginx/sbin/nginx %{buildroot}%{_bindir}/%{name}
ln -sf %{orprefix}/luajit/bin/luajit %{buildroot}%{_bindir}/lua
ln -sf %{orprefix}/luajit/bin/luajit %{buildroot}%{_bindir}/luajit

# to silence the check-rpath error
export QA_RPATHS=$[ 0x0002 ]

find %{buildroot}


%check
ls %{buildroot}%{orprefix}/nginx/sbin/nginx
ls %{buildroot}%{orprefix}/luajit/lib/libluajit-5.1.so.2.1.0
ls %{buildroot}%{orprefix}/luajit/bin/luajit-2.1.0-beta3

annocheck -v %{buildroot}%{orprefix}/nginx/sbin/nginx || echo "FAILED"
annocheck -v %{buildroot}%{orprefix}/luajit/lib/libluajit-5.1.so.2.1.0 || echo "FAILED"
annocheck -v %{buildroot}%{orprefix}/luajit/bin/luajit-2.1.0-beta3 || echo "FAILED"


%clean
rm -rf %{buildroot}

%files
%defattr(-,root,root,-)

%{_bindir}/%{name}
%{_bindir}/lua
%{_bindir}/luajit
%{orprefix}/bin/*
%{orprefix}/site/lualib/
%{orprefix}/luajit/*
%{orprefix}/lualib/*
%{orprefix}/nginx/html/*
%{orprefix}/nginx/logs/
%{orprefix}/nginx/sbin/*
%{orprefix}/nginx/tapset/*
%config(noreplace) %{orprefix}/nginx/conf/*
%{orprefix}/COPYRIGHT


%files resty
%defattr(-,root,root,-)

%{_bindir}/resty
%{orprefix}/bin/resty


%files opm
%defattr(-,root,root,-)

%{_bindir}/opm
%{orprefix}/bin/opm
%{orprefix}/site/manifest/
%{orprefix}/site/pod/

%files opentracing
%defattr(-,root,root,-)

%{orprefix}/nginx/modules/ngx_http_opentracing_module.so


%changelog
* Mon Jan 20 2020 cpaas-ops <cpaas-ops@redhat.com> - 1.17.4-6
Built by CPaaS

* Mon Jan 20 2020 cpaas-ops <cpaas-ops@redhat.com> - 1.17.4-5
Built by CPaaS

* Mon Jan 20 2020 cpaas-ops <cpaas-ops@redhat.com> - 1.17.4-4
Built by CPaaS

* Wed Jan 15 2020 cpaas-ops <cpaas-ops@redhat.com> - 1.17.4-3
Built by CPaaS

* Wed Jan 15 2020 cpaas-ops <cpaas-ops@redhat.com> - 1.17.4-2
Built by CPaaS


* Thu Jan 9 2020 Eloy Coto 1.17.4.1
- custom Openresty build.
* Thu May 16 2019 Yichun Zhang (agentzh) 1.15.8.1-1
- upgraded openresty to 1.15.8.1.
* Mon May 14 2018 Yichun Zhang (agentzh) 1.13.6.2-1
- upgraded openresty to 1.13.6.2.
* Sun Nov 12 2017 Yichun Zhang (agentzh) 1.13.6.1-1
- upgraded openresty to 1.13.6.1.
* Thu Sep 21 2017 Yichun Zhang (agentzh) 1.11.2.5-2
- enabled -DNGX_LUA_ABORT_AT_PANIC by default.
* Thu Aug 17 2017 Yichun Zhang (agentzh) 1.11.2.5-1
- upgraded OpenResty to 1.11.2.5.
* Tue Jul 11 2017 Yichun Zhang (agentzh) 1.11.2.4-1
- upgraded OpenResty to 1.11.2.4.
* Sat May 27 2017 Yichun Zhang (agentzh) 1.11.2.3-14
- bugfix: the openresty-opm subpackage did not depend on openresty-doc and openresty-resty.
* Sat May 27 2017 Yichun Zhang (agentzh) 1.11.2.3-14
- centos 6 and opensuse do not have the groff-base package.
* Sat May 27 2017 Yichun Zhang (agentzh) 1.11.2.3-13
- openresty-doc now depends on groff-base.
* Thu May 25 2017 Yichun Zhang (agentzh) 1.11.2.3-12
- added missing groff/pod2txt/pod2man dependencies for openresty-doc.
* Thu May 25 2017 Yichun Zhang (agentzh) 1.11.2.3-11
- added missing perl dependencies for openresty-opm, openresty-resty, and openresty-doc.
* Sun May 21 2017 Yichun Zhang (agentzh) 1.11.2.3-10
- removed the geoip nginx module since GeoIP is not available everywhere.
* Fri Apr 21 2017 Yichun Zhang (agentzh)
- upgrade to the OpenResty 1.11.2.3 release: http://openresty.org/en/changelog-1011002.html
* Sat Dec 24 2016 Yichun Zhang
- init script: explicity specify the runlevels 345.
* Wed Dec 14 2016 Yichun Zhang
- opm missing runtime dependencies curl, tar, and gzip.
- enabled http_geoip_module by default.
* Fri Nov 25 2016 Yichun Zhang
- opm missing runtime dependency perl(Digest::MD5)
* Thu Nov 17 2016 Yichun Zhang
- upgraded OpenResty to 1.11.2.2.
* Fri Aug 26 2016 Yichun Zhang
- use dual number mode in our luajit builds which should usually
be faster for web application use cases.
* Wed Aug 24 2016 Yichun Zhang
- bump OpenResty version to 1.11.2.1.
* Tue Aug 23 2016 zxcvbn4038
- use external packages openresty-zlib and openresty-pcre through dynamic linking.
* Thu Jul 14 2016 Yichun Zhang
- enabled more nginx standard modules as well as threads and file aio.
* Sun Jul 10 2016 makerpm
- initial build for OpenResty 1.9.15.1.

